pico-8 cartridge // http://www.pico-8.com
version 8
__lua__
started=false
sc1=0
sc2=0

--sfx
snd=
{
 jump=0,
 shot=1,
 explosion=2,
 die=25,
 win=26
}

--music tracks
mus=
{

}

//music(0)

-- effects

bullets={}
explosions={}

function shoot(x,y,d,i)
	sfx(snd.shot)
 bul={}
 bul.x=x
 bul.y=y
 bul.d=d
 bul.f=0
 bul.i=i
 bul.w=8
 bul.h=8
 add(bullets,bul)
end

function explode(x,y)
	sfx(snd.explosion)
 ex={}
 ex.x=x
 ex.y=y
 ex.t=0
 screenshake.t=5

 add(explosions,ex)
end

function dist(x1,y1,x2,y2)
 return sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
end

function updatebullets()
 for bul in all(bullets) do
  bul.x+=bul.d*5
  bul.f+=1
  if (bul.x < 0 or bul.x > 127) then   
  explode(bul.x,bul.y)
   screenshake.t=5
   del(bullets,bul)
  elseif collide_side(bul) then
  explode(bul.x,bul.y)
   screenshake.t=5
   del(bullets,bul)
  elseif (dist(bul.x,bul.y,player.x,player.y) < 8 and bul.i==2) then
player.x=64
		player.y=36
		p2.x=64
		p2.y=100
		  explode(bul.x,bul.y)
   screenshake.t=5
   del(bullets,bul)
   sc2+=1
   bullets={}
  elseif (dist(bul.x,bul.y,p2.x,p2.y) < 8 and bul.i==1) then
	player.x=64
		player.y=100
		p2.x=64
		p2.y=36
  explode(bul.x,bul.y)
   screenshake.t=5
   del(bullets,bul)
   sc1+=1
   bullets={}
  end
 end
end

function drawbullets()
 for bul in all(bullets) do
  flp=bul.d!=1
//  if (bul.i==1) pal(10,12)
  spr(21+bul.f%2, bul.x, bul.y,1,1,flp)
//  pal(10,10)
 end 
end

function drawexplosions()
 for ex in all(explosions) do
  circfill(ex.x,ex.y,ex.t,sget(56+ex.t/2.5,16))
 end
end

function updateexplosions()
	for ex in all(explosions) do
		ex.t+=2
		if (ex.t > 20) then
			del(explosions,ex)
		end
	end
end

screenshake={}
screenshake.t=0

--math
--------------------------------

--point to box intersection.
function intersects_point_box(px,py,x,y,w,h)
 if flr(px)>=flr(x) and flr(px)<flr(x+w) and
    flr(py)>=flr(y) and flr(py)<flr(y+h) then
  return true
 else
  return false
 end
end

--box to box intersection
function intersects_box_box(
 x1,y1,
 w1,h1,
 x2,y2,
 w2,h2)

 local xd=x1-x2
 local xs=w1*0.5+w2*0.5
 if abs(xd)>=xs then return false end

 local yd=y1-y2
 local ys=h1*0.5+h2*0.5
 if abs(yd)>=ys then return false end
 
 return true
end

--check if pushing into side tile and resolve.
--requires self.dx,self.x,self.y, and 
--assumes tile flag 0 == solid
--assumes sprite size of 8x8
function collide_side(self)

 local offset=self.w/3
 for i=-(self.w/3),(self.w/3),2 do
 --if self.dx>0 then
  if fget(mget((self.x+(offset))/8,(self.y+i)/8),0) then
   self.dx=0
   self.x=(flr(((self.x+(offset))/8))*8)-(offset)
   return true
  end
 --elseif self.dx<0 then
  if fget(mget((self.x-(offset))/8,(self.y+i)/8),0) then
   self.dx=0
   self.x=(flr((self.x-(offset))/8)*8)+8+(offset)
   return true
  end
-- end
 end
 --didn't hit a solid tile.
 return false
end

--check if pushing into floor tile and resolve.
--requires self.dx,self.x,self.y,self.grounded,self.airtime and 
--assumes tile flag 0 or 1 == solid
function collide_floor(self)
 --only check for ground when falling.
 if self.dy<0 then
  return false
 end
 local landed=false
 --check for collision at multiple points along the bottom
 --of the sprite: left, center, and right.
 for i=-(self.w/3),(self.w/3),2 do
  local tile=mget((self.x+i)/8,(self.y+(self.h/2))/8)
  if fget(tile,0) or (fget(tile,1) and self.dy>=0) then
   self.dy=0
   self.y=(flr((self.y+(self.h/2))/8)*8)-(self.h/2)
   self.grounded=true
   self.airtime=0
   landed=true
  end
 end
 return landed
end

--check if pushing into roof tile and resolve.
--requires self.dy,self.x,self.y, and 
--assumes tile flag 0 == solid
function collide_roof(self)
 --check for collision at multiple points along the top
 --of the sprite: left, center, and right.
 for i=-(self.w/3),(self.w/3),2 do
  if fget(mget((self.x+i)/8,(self.y-(self.h/2))/8),0) then
   self.dy=0
   self.y=flr((self.y-(self.h/2))/8)*8+8+(self.h/2)
   self.jump_hold_time=0
  end
 end
end

--
-- print functions
--
function printo(str,startx,
                starty,col,
                col_bg)
 print(str,startx+1,starty,col_bg)
 print(str,startx-1,starty,col_bg)
 print(str,startx,starty+1,col_bg)
 print(str,startx,starty-1,col_bg)
 print(str,startx+1,starty-1,col_bg)
 print(str,startx-1,starty-1,col_bg)
 print(str,startx-1,starty+1,col_bg)
 print(str,startx+1,starty+1,col_bg)
 print(str,startx,starty,col)
end


function printc(
 str,x,y,
 col,col_bg,
 special_chars)

 local len=(#str*4)+(special_chars*3)
 local startx=x-(len/2)
 local starty=y-2
 printo(str,startx,starty,col,col_bg)
end

function updateshake()

 if (screenshake.t > 0) then
  screenshake.t -= 1
  camx=rnd(5)-2.5
  camy=rnd(5)-2.5
  camera(camx,camy)
 else
  camera()
  camx=0
  camy=0
 end
end

-------------------
-- actor functions
-------------------
function actor(ix,iy,iw,ih,a,p)
 local actor={
 x=ix,
 y=iy,

 w=iw,
 h=ih,
 anims=a,
 sd=0,
 
 

  dx=0,
  dy=0,
  
  max_dx=2,--max x speed
  max_dy=2,--max y speed

  jump_speed=-1.75,--jump veloclity
  acc=0.2,--acceleration
  dcc=0.8,--decceleration
  air_dcc=1,--air decceleration
  grav=0.15,
 
 curanim="stand",--currently playing animation
 curframe=1,--curent frame of animation.
 animtick=0,--ticks until next frame should show.
 flipx=false,--show sprite be flipped.
 
 
  jump_hold_time=0,--how long jump is held
  min_jump_press=5,--min time jump can be held
  max_jump_press=15,--max time jump can be held

  jump_btn_released=true,--can we jump again?
  grounded=false,--on ground

  airtime=0,--time since grounded
 
 jump_button=
  {
   update=function(self)
    --start with assumption
    --that not a new press.
    self.is_pressed=false
    if btn(2,p) then
     if not self.is_down then
      self.is_pressed=true
     end
     self.is_down=true
     self.ticks_down+=1
    else
     self.is_down=false
     self.is_pressed=false
     self.ticks_down=0
    end
   end,
   --state
   is_pressed=false,--pressed this frame
   is_down=false,--currently down
   ticks_down=0,--how long down
  },
 
 --request new animation to play.
  set_anim=function(self,anim)
   if(anim==self.curanim)return--early out.
   local a=self.anims[anim]
   self.animtick=a.ticks--ticks count down.
   self.curanim=anim
   self.curframe=1
  end,

  --draw the player
  draw=function(self)
   local a=self.anims[self.curanim]
   local frame=a.frames[self.curframe]
   spr(self.w/8*frame,
    self.x-(self.w/2),
    self.y-(self.h/2),
    self.w/8,self.h/8,
    self.flipx,
    false)
  end,
  
  updateanim=function(self)
    --anim tick
   self.animtick-=1
   if self.animtick<=0 then
    self.curframe+=1
    local a=self.anims[self.curanim]
    self.animtick=a.ticks--reset timer
    if self.curframe>#a.frames then
     self.curframe=1--loop
    end
   end
  end,
  
  updatefall=function(self)
     --move in y
   self.dy+=self.grav
   self.dy=mid(-self.max_dy,self.dy,self.max_dy)
   self.y+=self.dy

   --floor
   if not collide_floor(self) then
    self:set_anim("jump")
    self.grounded=false
    self.airtime+=1
   end

   --roof
   collide_roof(self)

   if self.grounded then
    self:set_anim("walk")
   end
  end,

   --call once per tick.
  update=function(self)
  end,
 }
 
 return actor
end

anims=
  {
   ["stand"]=
   {
    ticks=1,--how long is each frame shown.
    frames={0},--what frames are shown.
   },
   ["walk"]=
   {
    ticks=2,
    frames={0,1,2,3,2,1},
   },
   ["jump"]=
   {
    ticks=1,
    frames={0},
   },
   ["slide"]=
   {
    ticks=1,
    frames={0},
   },
  }

player=actor(64,36,8,8,anims,0)
player:set_anim("stand")

p2=actor(64,100,8,8,anims,1)
p2:set_anim("stand")

function p2:update()
  --track button presses
   local bl=btn(0,1) --left
   local br=btn(1,1) --right
   
   --move left/right
   if bl==true then
    self.dx-=self.acc
    br=false--handle double press
   elseif br==true then
    self.dx+=self.acc
   else
    if self.grounded then
     self.dx*=self.dcc
    else
     self.dx*=self.air_dcc
    end
   end

			if (self.sd > 0) then
				self.sd -= 0.1
			end
   if btn(4,1) then
    if (self.flipx and self.sd <= 0) then
     shoot(self.x,self.y-4,-1,2)
   		self.sd=0.5
    elseif (self.flipx != true and self.sd <=0) then
     shoot(self.x,self.y-4,1,2)
    	self.sd=0.5
    end
   end

   --limit walk speed
   self.dx=mid(-self.max_dx,self.dx,self.max_dx)
   
   --move in x
   self.x+=self.dx
   
   --hit walls
   collide_side(self)

   --jump buttons
   self.jump_button:update()
   
   --jump is complex.
   --we allow jump if:
   -- on ground
   -- recently on ground
   -- pressed btn right before landing
   --also, jump velocity is
   --not instant. it applies over
   --multiple frames.
   if self.jump_button.is_down then
    --is player on ground recently.
    --allow for jump right after 
    --walking off ledge.
    local on_ground=(self.grounded or self.airtime<5)
    --was btn presses recently?
    --allow for pressing right before
    --hitting ground.
    local new_jump_btn=self.jump_button.ticks_down<10
    --is player continuing a jump
    --or starting a new one?
    if self.jump_hold_time>0 or (on_ground and new_jump_btn) then
     if(self.jump_hold_time==0)sfx(snd.jump)--new jump snd
     self.jump_hold_time+=1
     --keep applying jump velocity
     --until max jump time.
     if self.jump_hold_time<self.max_jump_press then
      self.dy=self.jump_speed--keep going up while held
     end
    end
   else
    self.jump_hold_time=0
   end
   
   self.updatefall(self)

   --handle playing correct animation when
   --on the ground.
   if self.grounded then
    if br then
     if self.dx<0 then
      --pressing right but still moving left.
      self:set_anim("slide")
     else
      self:set_anim("walk")
     end
    elseif bl then
     if self.dx>0 then
      --pressing left but still moving right.
      self:set_anim("slide")
     else
      self:set_anim("walk")
     end
    else
     self:set_anim("stand")
    end
   end

   --flip
   if br then
    self.flipx=false
   elseif bl then
    self.flipx=true
   end

   self.updateanim(self)
end


function player:update()
  --track button presses
   local bl=btn(0,0) --left
   local br=btn(1,0) --right
   
   --move left/right
   if bl==true then
    self.dx-=self.acc
    br=false--handle double press
   elseif br==true then
    self.dx+=self.acc
   else
    if self.grounded then
     self.dx*=self.dcc
    else
     self.dx*=self.air_dcc
    end
   end

			if (self.sd > 0) then
				self.sd -= 0.1
			end
   if btn(4,0) then
    if (self.flipx and self.sd <= 0) then
     shoot(self.x,self.y-4,-1,1)
   		self.sd=0.5
    elseif (self.flipx != true and self.sd <=0) then
     shoot(self.x,self.y-4,1,1)
    	self.sd=0.5
    end
   end

   --limit walk speed
   self.dx=mid(-self.max_dx,self.dx,self.max_dx)
   
   --move in x
   self.x+=self.dx
   
   --hit walls
   collide_side(self)

   --jump buttons
   self.jump_button:update()
   
   --jump is complex.
   --we allow jump if:
   -- on ground
   -- recently on ground
   -- pressed btn right before landing
   --also, jump velocity is
   --not instant. it applies over
   --multiple frames.
   if self.jump_button.is_down then
    --is player on ground recently.
    --allow for jump right after 
    --walking off ledge.
    local on_ground=(self.grounded or self.airtime<5)
    --was btn presses recently?
    --allow for pressing right before
    --hitting ground.
    local new_jump_btn=self.jump_button.ticks_down<10
    --is player continuing a jump
    --or starting a new one?
    if self.jump_hold_time>0 or (on_ground and new_jump_btn) then
     if(self.jump_hold_time==0)sfx(snd.jump)--new jump snd
     self.jump_hold_time+=1
     --keep applying jump velocity
     --until max jump time.
     if self.jump_hold_time<self.max_jump_press then
      self.dy=self.jump_speed--keep going up while held
     end
    end
   else
    self.jump_hold_time=0
   end
   
   self.updatefall(self)

   --handle playing correct animation when
   --on the ground.
   if self.grounded then
    if br then
     if self.dx<0 then
      --pressing right but still moving left.
      self:set_anim("slide")
     else
      self:set_anim("walk")
     end
    elseif bl then
     if self.dx>0 then
      --pressing left but still moving right.
      self:set_anim("slide")
     else
      self:set_anim("walk")
     end
    else
     self:set_anim("stand")
    end
   end

   --flip
   if br then
    self.flipx=false
   elseif bl then
    self.flipx=true
   end

   self.updateanim(self)
end

------------------
-- main functions
------------------
dead=0
function _update()
if (started) then
if (sc1 < 3 and sc2 < 3) then
 updateshake()
 updateexplosions()
 updatebullets()
 player:update()
 p2:update()
else
dead+=0.1
 updateshake()
 updateexplosions()
 updatebullets()
end
else
 if (btn(4)) then
  started=true
 end
end
end

function _draw()
if (started) then
if (dead<5) then
cls()
map(0,0,0,0,16,16)
player:draw()
pal(7,14)
p2:draw()
pal(7,7)
drawbullets()
drawexplosions()

printo(sc1,2, 4,7,1)
printo(sc2,127-4, 4,14,1)
else
for i=0,10000 do
x=rnd(128)
y=rnd(128)
if (pget(x,y)==1 or pget(x,y)==7 or pget(x,y)==8) then
	pset(x,y+1,8)
	if(sc1>=10) then
		printo("player one won",32,64,7,1)
	else
		printo("player two won",32,64,7,1)

	end
end
end
end
else
cls()
sspr(0,32,128,128,0,32)

-- printo("by maciej 'mantis' kozlowski",10, 118,7,1)
 printo("press (z) to start", 30, 110,7,1)
end
end
__gfx__
00444400000000000000000000444400007777000044440000000000004444000000000000000000000000000000000000000000000000000000000000000000
047777000044440000444400047777000777770004777700004444000477770066664440000f0000000000000000000000000000000000000000000000000000
047cfc000477770004777700047cfc0007777700047cfc0004777700047cfc007777777447cf0007000000000000000000000000000000000000000000000000
0477fff0047cfc00047cfc000477fff0077777700477fff0047cfc000477fff070007c7447ff0007000000000000000000000000000000000000000000000000
067888000677fff00677fff00678880007777700067888000677fff0067000007000ff7447c70007000000000000000000000000000000000000000000000000
06777700067888000678880006777700077777000677770006788800067000007000fc7447777777000000000000000000000000000000000000000000000000
06005000067777000677770005006000070070000600500006777700067000000000f00004446666000000000000000000000000000000000000000000000000
06605500006650000056600005506600077077000660550006605500067777000000000000000000000000000000000000000000000000000000000000000000
000000000999990000000000000000000000000000000000000000007776666d7777766d667777776666666d6666666d7776666d000000000000000000000000
099999000998990000665500000000000000000000000000000000007756675d7757675d675777576656675d6756675d7756675d000000000000000000000000
099899000999990006888850000000000000000000099990009999907666666d7776666d777777776666666d6666666d7666666d000000000000000000000000
09999900090999000688875000000050505000009aaaaaa909aaaaa96666666d7766666d77777777666666676666666d6666666d000000000000000000000000
090999000000990005877750000000000000000009aaaaa99aaaaaa96666666d7666666d77777777666666776666666d6666666d000000000000000000000000
000099000000990005877150000000505500000000999990000999906756675d6756675d77577757675667576756675d6756675d000000000000000000000000
0999990009999900057111500005055995505000000000000000000066666ddd66666ddd7777777d6666777766666ddd66666ddd000000000000000000000000
0090090000900900051111500000009aa90000000000000000000000dddddddddddddddd777777ddddd7777ddddddddddddddddd000000000000000000000000
555555557776666d070507050005059aa9505000000990000009900077aaa9999455555500000000000000000000000000000000000000000000000000000000
50aa00a57756675d060706070000055995500000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
5aa00aa57666666d060606060005005055005000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
5a00aa056666666d050605060000000000000000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
500aa0056666666d070507050000005050500000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
50aa00a56756675d060706070000000000000000000aa900009aa000000000000000000000000000000000000000000000000000000000000000000000000000
5aa00aa566666ddd060606060000000000000000000a90000009a000000000000000000000000000000000000000000000000000000000000000000000000000
55555555dddddddd0506050600000000000000000009000000009000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000007777770000000000009000000009000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000007765567700000000000a90000009a000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000007650056700000000000aa900009aa000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000006500005600000000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
0008a000000a8000000000006500005600000000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
00889a0000a98800000000006500005600000000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
0088990000998800000880006500005600000000009aa900009aa900000000000000000000000000000000000000000000000000000000000000000000000000
00444400004444000333333066666666000000000009900000099000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000ddd000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000ddddddd000000dddddddddddddddd000dddddd0000000dddddddddd0000000ddd0000000000000000000000000000000000000000000000000000000000
0000dddddddd000000dddddddddddddddd000dddddd0000000dddddddddd0000000dddd000000000000000000000000000000000000000000000000000000000
0000ddd0000000000000000dd0000000dd000dd00ddd00000000000000dd0000000dddd0000000000000dd00000000000dd00000000000000000000000000000
000ddd00000000000000000dd00000000000ddd00ddd00000000000000dd000000dddddd000000000000dd00000000000ddd000000000dd00000000000000000
000dd000000000000000000dd00000000000ddd000dd0000000000000ddd000000dd00ddd00000000000dd00000000000dddd00000000dd00000000000000000
000ddd00000000000000000ddd0000000000dd0000dd000000000000ddd0000000dd000ddd0000000000dd0000000000000ddd000000ddd00000000000000000
000ddddddddddddd00000000dd0000000000dd00dddd000000000000dd00000000dd0000ddd000000000dd00000000000000dddddddddd000000000000000000
00000dddddddddddd0000000dd0000000000dd00ddd0000000000000dd00000000dd00000dd000000000dd0000000dd000000ddddddddd000000000000000000
00000000000000dddd000000dd0000000000dd0ddd00000000000000dd0000000ddd00000ddd00000000dd000000ddd000000000dd0000000000000000000000
000000000000000ddd000000dd0000000000dd0dd00000000000000ddd0000000dd0000000dd00000000dd00000dddd000000000dd0000000000000000000000
0000000000000000dd000000dd0000000000dd0dddd00000000000ddd00000000dddddddddddddd00000dd0000dddd0000000000dd0000000000000000000000
000000000000000ddd000000dd0000000000dd00ddddd000000000dd000000000dddddddddddddd00000dd00ddddd00000000000dd0000000000000000000000
00000000000000ddd0000000dd0000000000dd0000dddd0000000ddd000000000dd00000000dd0000000dddddddd000000000000dd0000000000000000000000
0000000000000ddd00000000dd0000000000dd00000dddd00000ddd000000000ddd00000000ddd000000ddddd00000000000000ddd0000000000000000000000
00000ddd00dddddd00000000ddd000000000dd000000dddd000ddd0000000000dd000000000ddd000000dd00000000000000000dd00000000000000000000000
00000ddddddddd0000000000ddd000000000dd0000000ddd000dddddddd00000dd0000000000dd000000dd0000000000000000ddd00000000000000000000000
000000ddddd0000000000000000000000000000000000000000dddddddd00000dd0000000000dd000000dd0000000000000000ddd00000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000dd0000000000dd00000ddddddddd0000000000dd000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000ddddddddd000000000ddd000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dd0000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dd0000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000ddd0000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dd00000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000ddd00000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dd000000000000000000000000000
000000000000000000000000000000000000000ddd000000000000000000000000000000000000000000000000000000000dd000000000000000000000000000
0000000000000000ddddddddddddddd00000000ddd0000000000000000000000000000000000ddd0000000000000000000000000000000000000000000000000
0000000000000000ddddddddddddddd0000000ddddd00000000dd000000dd000000000000000ddd0000000000000000000000000000000000000000000000000
00000000000000000000000000000dd0000000ddddd00000000dd000000dd0000000000000ddddd0000000000000000000000000000000000000000000000000
0000000000000000000000000000ddd0000000dd0ddd000000ddd000000dd000000dd0000dddd000000000000000000000000000000000000000000000000000
000000000000000000000000000ddd00000000dd00ddd00000ddd000000dd000000dd0000ddd000000000000ddd0000000000000000000000000000000000000
000000000000000000000000000dd000000000dd000ddd0000dd0000000dd000000dd000ddd0000000000000ddd000000000ddddddddd0000000000000000000
00000000000000000000000000ddd000000000dd0000dd000ddd0000000dd000000dd00ddd0000000000000dddd000000000ddddddddd0000000000000000000
0000000000000000000000000ddd0000000000dd0000dd000dd00000000dd000000dd0ddd0000000000000ddddd0000000000dd0000ddd000000000000000000
00000000000000000000000dddd00000000000dd0000ddd00dd0000000ddd000000dddddd0000000000000ddddd0000000000dd00000dd000000000000000000
0000000000000000000000dddd00000000000ddd00000dd0ddd0000000dd0000000dddddd000000000000ddd0ddd000000000dd00000dd000000000000000000
00000000000000000000dddd0000000000000dd000000ddddd00000000dd0000000dddddd000000000000dd000ddd00000000dd00000dd000000000000000000
0000000000000000000dddd00000000000000dd000000ddddd00000000dd0000000dd00dddd000000000ddd000ddd00000000dd00000ddd00000000000000000
000000000000000000ddd0000000000000000dd0000000ddd000000000dd0000000dd000dddd00000000dd00000dd00000000dd000000dd00000000000000000
0000000000000000dddddddddddd000000000dd0000000dd000000000ddd0000000dd0000dddd0000000ddddddddddd000000dd000000dd00000000000000000
000000000000000dddddddddddddddd000000dd000000000000000000ddd0000000dd00000ddd000000dddddddddddd000000dd00000ddd00000000000000000
000000000000000dddddd000000dddd00000000000000000000000000dd0000000ddd000000ddd0000ddd000000ddd0000000dd00000ddd00000000000000000
000000000000000000000000000000000000000000000000000000000000000000ddd000000dddd000ddd0000000dd0000000dd00000dd000000000000000000
000000000000000000000000000000000000000000000000000000000000000000dd00000000ddd000dd00000000dd0000000dd0000ddd000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000dd00000000ddd000000dd000ddd0000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dd000000dddddddd0000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dd000000ddddddd00000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000ddd0000000dddd0000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000ddd000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000ddd0000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dd00000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000ddd00000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dddddd00000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000dddddd00000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__gff__
0000000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__map__
2121212121212121212121212121212100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100131400000013140000001314002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100232400000023240000002324002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100000000000000000000000000002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100000000000000000000000000002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100000021212121212121210000002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100131400000013140000001314002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100232400000023240000002324002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2121000000000000000000000000212100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100000000000000000000000000002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100002121212121212121212100002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100131400000013140000001314002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2100232400000023240000002324002100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2121210000000021210000000021212100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2121210000000021210000000021212100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
2121212121212121212121212121212100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__sfx__
010800000f051180510f000030000e0000160012600116000d6000000000000010000100001000010000100001000010000100000000000000100001000010000d600000000d6001900000000000000000000000
010300001815015153081552c0002c0002d0002d0002d0002c0002c0002a00027000240001f0001d0001800013000110000e0000c000080000600000000000000000000000000000000000000000000000000000
00040000296502c6502f6501f65018650126500d6500b6500965005640056400362003620036100260002600016000000000000000000f0000f00000000000000c0000000000000000000f0000f0000c0000c000
0105000001633000000260011633206330160008633016002e6330000000000016000163300000000000000001600000000000000000096330160000000000002e6332e600000000000000000156000000001600
010500000b0540b05500000000000b0540b05500005000050b0540b05500005000050b0540b05500005000051205412055000050c005120541205512005000051205412055000050000512054120550000000000
010500000e0540e05500005000050e0540e05500005000050e0540e05500005000050e0540e055000050000510054100550000500005100541005500005000051005410055000050000510054100550000000000
00050000175441754017540185001a5401a5401a540182001c0001c0001c000180001c5401c5401c5401c54018500185001f5001f5001f5401f5401f5421f5421f5421f5421f5421f50000500005000050000500
010c00161f0501c0501d000210501f050180001f0501c0501a0001a0501a00014050170001c0502105020000200501e0501000010000190001e500180001f002180001e5021e5021c00014000200001e00000500
01050000175441754017540185001a5401a5401a540185001c5001c5001c500185001c5401c5401c5401c54018500185001f5001f5001f5401f5401f5401f5401f5401b5001e5001e5001e5401e5401e5401e540
010500001e5401e5001e5001c5001c5401c5401c5401c5401c5401850018500185001a5401a5401a5401a5401a5401850018500185001c5401c5401c5421c5421c5421c5421c5421c54218500185001850018500
000500001732000300003000030012320003000030000300173200030000300003001232000300003000030017320003000030000300123200030000300003001732000300003000030012320001000010000000
000500001732000300003000f300103200f3000030000300173200030000300003001032000300003000030017320003000030000300123200030000300003001732000300003000030012320003000030000300
010200002276422761227612276125761257612576125761287662876628766287662876628766287662876628766287662876628766287662876628766287662876628766287662876628766287662876628765
0102000022707227072270722701257012570125701257012b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b7672b765
0102000022706227062270622206250062570625706257062e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e7662e765
0106000001643026000160000000016430000001600000000164300000016000000001643000000000000000016430d6000000000000016430000000000000000164300000000000000001643000000000000000
010400003923332100011000010015233155030120000200392333020031200302001523330200302003020039233302003020030200152333020030200302003923330200302003020015233300003000030000
0001000006611096210c6311064114651176511965120661256612e661346713c6730165301653016530000000000000000000000000000000000000000000000000000000000000000000000000000000000000
010400001e52321531205412455125561285512754127551275512756125551275512855128561285712756127551275412655127561275612755126541275512755127561265512756126551265512554126524
000300002c66018430184000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0004000022621211311d631072771f6211e141072772064123141236311f15123651072772463125151256311515124651181311764128131256510727717641251512463116631072772163129121256411c151
010f00000e6510e6410e6310c6210a6150e6010e6010d6010c6010b6010a60506643086310b6310c6410c6510c6510c6410c6310a621086150d6040e6010e6010e6010e6010e6010b6330c6210e6310e6410f651
00010000066110a6210e63114641196511f6612766132661396610164101641016030160301603016030000000000000000000000000000000000000000000000000000000000000000000000000000000000000
010800000825008250082500815008256082560825608256082560825608256082560815608256082560825608257082570815708257082570825708257082570825708157082570815708257082570825708257
011200001561039603000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
011200001844311303143030000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
010800002515023000251501e000251502300031150311603114031150311503115031150311503115031155361003610036100361042e1002e10000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__music__
04 07464344
00 43424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344

